/* Datei: moviedatabase.c */
#include <stdio.h>

enum Medium {MEDIUM_DVD, MEDIUM_BLUERAY};

struct Movie
{
   enum Medium medium;
   char        name[50];
   int         dauer;
   const char* tags[10];
};

void printMovie (const struct Movie * movie)
{
   int tagindex = 0;
   if (movie->medium == MEDIUM_DVD)
   {
      printf ("DVD: \"");
   }
   if (movie->medium == MEDIUM_BLUERAY)
   {
      printf ("BlueRay: \"");
   }
   printf ("%s", movie->name);
   printf ("\", %d Minuten\nTags:\n", movie->dauer);
   while (movie->tags[tagindex])
   {
      printf ("\"%s\"\n", movie->tags[tagindex]);
      tagindex++;
   }
   printf ("\n");
}

int main (void)
{
   struct Movie film1 = 
   {
      MEDIUM_BLUERAY,
      "Lion King",
      85,
      {"Simba", "Circle of Life"}
   };
   struct Movie film2 = 
   {
      MEDIUM_DVD,
      "Terminator 2",
      147,
      {"Bad to the bone", "T-1000", "Hasta la vista"}
   };
   
   printMovie (&film1);
   printMovie (&film2);
   return 0;
}

