/* Datei: b_suchen.c */
#include <stdio.h>
#define N 15

int binaer_suchen (int suchbegriff, int feld [], int n)
/* Sucht "suchbegriff" im int-array "feld" mit binaerem Suchen.   */
/* Parameter:     suchbegriff = zu suchendes Element              */
/*                feld        = Array, in dem gesucht wird        */
/*                n           = Laenge des Feldes                 */
/* Rueckgabewert: Position des gesuchten Elementes (0 .. n-1)     */
/*                oder -1, wenn das Element nicht gefunden wird.  */
{
   int low = 0;
   int high = n - 1;
   int mid;

   while (low <= high)
   {
      mid = (low + high) / 2;
      if (suchbegriff < feld[mid])
         high = mid - 1;
      else if (suchbegriff > feld[mid])
         low = mid + 1;
      else
         return mid;  /* gefunden       */
   }
   return -1;         /* nicht gefunden */
}

int main (void)
{
   int index, suchbegriff, x [N], lv;
   printf ("Inhalt\tIndex\n");
   for (lv = 0; lv < N; lv++) 
   {
      x[lv] = lv * 2;
      printf ("%6d\t%5d\n", x[lv], lv);
   }
   printf ("Bitte Suchbegriff eingeben: ");
   scanf ("%d", &suchbegriff);
   
   index = binaer_suchen (suchbegriff, x, N);
   if (index == -1)
      printf ("Nicht gefunden \n");
   else
      printf ("Element = %d hat Index = %d\n", suchbegriff, index);

   return 0;
}





