/* Datei: hash2.c */
/* Funktionen zur Verwaltung von Hashtabellen mit linearer      */
/* schluesselabhaengiger Sondierung als Konfliktstrategie.      */
/* Die Funktion "hash (schl, &delta)" wird zur Berechnung der   */
/* Anfangsposition aufgerufen, waehrend "rehash (schl, delta)"  */
/* bei jedem Konflikt aufgerufen werden muss.                   */

unsigned hash (unsigned schl, unsigned * delta)
{  /* Einfache Hashfunktion                                     */
   *delta = max (1, schl / grenze) % grenze;
   return (schl % grenze);
}

unsigned rehash (unsigned schl, unsigned delta)
{  /* Lineares Sondieren mit schluesselabhaengiger              */
   /* Schrittweite als Konfliktstrategie                        */
   return ((schl + delta) % grenze);
}