/* Datei: laby.c */
#include <stdio.h>
#include <windows.h>

enum {ZEILEN=3000, SPALTEN=6000};  /* Maxima ... */

/* Mgliche Richtungen beim Suchen: */
enum eRichtungen {OST, SUED, WEST, NORD};

/* Mgliche Markierungen im Labyrinth: */
enum eMarkierungen {WAND='#', FREI=' ', WEG='+', IRRWEG='x',
                   ZIEL='Z'};

/* Wie verlief die Suche in einem Teilast?: */
enum eSuchErgebnis {MISSERFOLG, ERFOLG};

/* Zu programmierende Funktion... */
enum eSuchErgebnis sucheImLabyrinth (unsigned int uiZeile,
                                     unsigned int uiSpalte);

/* Zweidimensionales, globales Array, das das Labyrinth und dessen (Irr-) Wege speichert */
char gacZellen[ZEILEN][SPALTEN] 
= {   "#########################",
      "#S#     # #             #",
      "# # ### # # # # #########",
      "#   # #   # # #     #   #",
      "# # # # ### # ##### # # #",
      "# #   #     #     #   # #",
      "# ############# ### ### #",
      "#       #     # #   # # #",
      "####### # ### # # ### # #",
      "#       #   # # #     # #",
      "# ### ##### # ####### ###",
      "#   #     # # #     #   #",
      "##### ### # # # ### ### #",
      "#     #   # # # # # #   #",
      "# ######### # # # # # # #",
      "#           # #   #   #Z#", 
      "#########################"
};

void printLabyrinth (unsigned int uiZeilen, 
                     unsigned int uiSpalten)
{
   unsigned int uiZeile, uiSpalte;

   system("cls");  
   for (uiZeile=0; uiZeile < uiZeilen; uiZeile++)
   {
      printf ("\n");
      for (uiSpalte=0; uiSpalte < uiSpalten; uiSpalte++)
      {
         printf ("%c", gacZellen[uiZeile][uiSpalte] );
      }
   }
   printf ("\n");
   Sleep (500);    
}

enum eSuchErgebnis sucheImLabyrinth (unsigned int uiZeile, 
                                     unsigned int uiSpalte)
{ if (gacZellen[uiZeile][uiSpalte] != 'Z')                   /*(1)*/
   {  if (gacZellen[uiZeile][uiSpalte] == ' ')               /*(2)*/
      {  enum eRichtungen eLfdRichtung;
         gacZellen[uiZeile][uiSpalte] = '+'; /* Weg markieren  (3)*/
         printLabyrinth (17, 26);  

		/* In jede Richtung rekursiv eine neue Suche starten:     (4)*/
         for (eLfdRichtung = OST; eLfdRichtung <= NORD;
              eLfdRichtung++)
         {  enum eSuchErgebnis retWert;
            switch(eLfdRichtung)
            {
            case OST: retWert = sucheImLabyrinth (uiZeile,
                                                  uiSpalte + 1); 
               break;
            case SUED:retWert = sucheImLabyrinth (uiZeile +1,
                                                  uiSpalte   ); 
               break;
            case WEST:retWert = sucheImLabyrinth (uiZeile,
                                                  uiSpalte - 1); 
               break;
            case NORD: retWert = sucheImLabyrinth (uiZeile-1,
                                                   uiSpalte   ); 
               break;
            }
            if (retWert == ERFOLG) 
            {  /* Weitere Suche zwecklos, Ziel gefunden... */
               return retWert;
            }
         }
         /* Ummarkieren, da Sackgasse */
         gacZellen[uiZeile][uiSpalte] = 'x'; 
         printLabyrinth (17, 26);  
		 
		 return MISSERFOLG;
      }
      else
	  {
	     return MISSERFOLG;
      }
   }
   else
   {
	  return ERFOLG;
   }
}


int main(void)
{
   int i;
   // Vorbereitung
   printLabyrinth (17, 26);  
   i = getchar();
   gacZellen[1][1] = ' ';

   //Jetzt gehts los
   if (sucheImLabyrinth (1,1) == ERFOLG)
   {
	   // Jubel, falls gefunden  
	   printLabyrinth (17, 26);
       for (i=0; i < 10; i++)
	   { 
	     printf ("\a");
	   }
   } 
   
   return 0;
}





