/* Datei: staticthreadvar.c */
#include <stdio.h>
#include <threads.h>
#include <stdbool.h>

/* Terminierungsvariable (vereinfacht, nicht synchronisiert) */
int terminate = false;

/* globale Variabl fuer Mutex */
mtx_t mutex;

/* Thread Funktion */
int threadfunction (void * arg)
{
   (void) arg; /* wird nicht verwendet */
   static int cnt = 0;

   while (true)
   { 
      mtx_lock (&mutex);   /* Mutex sperren */
      cnt++;               /* Variable inkrementieren */
      printf ("cnt = %03i, Thread 0x%08x\n", cnt, 
								(int)thrd_current().p);
      mtx_unlock (&mutex); /* Mutex freigeben */
      if (terminate == true) 
      {
         break;
      }
      thrd_yield();
   }
   return thrd_success;
}

int main (void) 
{
   /* Variable zum Speichern der Thread ID */
   thrd_t thr1, thr2, thr3, thr4;

   /* Initialisierung des Mutexes und Erzeugung der Threads*/
   mtx_init (&mutex, mtx_plain);
   thrd_create (&thr1, threadfunction, NULL);
   thrd_create (&thr2, threadfunction, NULL);
   thrd_create (&thr3, threadfunction, NULL);
   thrd_create (&thr4, threadfunction, NULL);

   for (int i = 0; i < 1e8; i++) 
   {
       /* eine Weile warten... */
   }

   /* Beenden der Threads und Freigeben des Mutexes */
   terminate = true;
   thrd_join (thr1, NULL);
   thrd_join (thr2, NULL);
   thrd_join (thr3, NULL);
   thrd_join (thr4, NULL);
   mtx_destroy (&mutex);
}